<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/11/10
 * Time: 上午10:27
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ThreadController extends Controller
{

    /**
     * 主题详细页
     */
    public function actionGetthread()
    {
        global $_G;

        $data = array(
            'thread' => array(),//主题内容
            'replies' => array(),//主题回复
            'hotpings' => array()//热门评论
        );

        //主题帖ID
        $tid = Yii::app()->request->getPost('tid', 0);
        //只看某个回复
        $replypid = WebHelper::getPost('replypid', 0);
        //是否只看楼主
        $isseemaster = Yii::app()->request->getPost('isseemaster', 0);
        //回复排序
        $replyorder = Yii::app()->request->getPost('replyorder', 0);
        //点赞排序
        $supportorder = Yii::app()->request->getPost('supportorder', 2);
        //SQL OFFSET
        $offset = Yii::app()->request->getPost('offset', 0);
        //SQL limit
        $limit = Yii::app()->request->getPost('limit', 10);

        //多少条评论显示热门
        $commentlimit = Yii::app()->request->getPost('commentlimit', 10);
        //多少赞上热门
        $supportnum = Yii::app()->request->getPost('supportnum', 5);
        //最多显示多少热门
        $supportlimit = Yii::app()->request->getPost('supportlimit', 10);

        //缓存期间的阅读量（前面设置的是10秒）
        $readnum = Yii::app()->request->getPost('readnum', 1);

        //判断是否为新APP的接口
        $is_new = Yii::app()->request->getPost('is_new', 0);

        /********************************************加载主题帖*********************************************************/
        $topic = C::t('forum_thread')->fetch_by_tid_displayorder($tid, ForumThread::DISPLAY_ORDER_NORMAL);
        $topicCheck = C::t('forum_thread')->fetch_by_tid_displayorder($tid, ForumThread::DISPLAY_ORDER_CHECK, '=');
        // 审核中,用户可以看见自己的审核中的帖子
        if (!empty($topicCheck)) {
            if (isset($_G['uid']) && $_G['uid'] > 0 && $topicCheck['authorid'] == $_G['uid']) {
                $topic = $topicCheck;
            } else {
                Tool::getInstance()->fail_json(Code::THREAD_CHECK, Tool::getInstance()->lang('thread is check'));
            }
        }

        //主题帖不存在
        if (empty($topic)) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }
        //保留移动贴
        //大坑 closed =1 可能代表是关闭主题，不是新移动帖地址
        if ($topic['closed'] && $topic['closed'] != 1) {
            $tid = $topic['closed'];
            $topic['tid'] = $tid;
        }
        /*************************************************************************************************************/

        /******************************加载板块信息****************************/
        $_GET['tid'] = $tid;
        $_GET['fid'] = $topic['fid'];

        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }

        loadforum();

        //兼容手机端 DISCUZ 模板，主要是为了返回的图片的SRC是静态地址
        //手机版也使用网页端的模板
        $tempMobileTpl = $_G['mobiletpl'][IN_MOBILE];
        if (defined('IN_MOBILE')) {
            if (!defined('TPL_DEFAULT')) {
                define('TPL_DEFAULT', true);
            }
            $_G['mobiletpl'][IN_MOBILE] = '';
        }

        /********************************************************************/
        //检查板块访问权限
        require_once(Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php');
        if (empty($_G['forum']['allowview'])) {
            if (!$_G['forum']['viewperm'] && !$_G['group']['readaccess']) {
                Tool::getInstance()->fail_json(Code::GROUP_HAS_NOT_PERMISSION, Tool::getInstance()->lang('your group:{group} can not read this content', array('{group}' => $_G['group']['grouptitle'])));
            } elseif ($_G['forum']['viewperm'] && !forumperm($_G['forum']['viewperm'])) {
                $res = qf_showmessagenoperm('viewperm', $_G['fid'], $_G['forum']['formulaperm']);
                $res = qf_rebuild4formulaperm($res);
                Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags(lang('message', $res['message'], $res['params'])));
                //Tool::getInstance()->fail_json();
                die('to do');
            }

        } elseif ($_G['forum']['allowview'] == -1) {
            //板块不允许被访问
            Tool::getInstance()->fail_json(Code::FORUM_NOPERMISSION, Tool::getInstance()->lang('forum can not read'));
        }

        /*
        if( $_G['forum']['formulaperm'] ) {
            die('to do');
        }
        */
        //需要密码才能访问板块
        if ($_G['forum']['password']) {
            Tool::getInstance()->fail_json(Code::NEED_PASSWORD, Tool::getInstance()->lang('need password to visit'));
        }

        /*
        if($_G['forum']['price'] && !$_G['forum']['ismoderator']) {
            $membercredits = C::t('common_member_forum_buylog')->get_credits($_G['uid'], $_G['fid']);
            $paycredits = $_G['forum']['price'] - $membercredits;
            if($paycredits > 0) {
                // dheader("Location: $_G[siteurl]forum.php?mod=forumdisplay&fid=$_G[fid]");
            }
        }
        */

        //应该是帖子阅读权限的判断
        if ($_G['forum_thread']['readperm'] && $_G['forum_thread']['readperm'] > $_G['group']['readaccess'] && !$_G['forum']['ismoderator'] && $_G['forum_thread']['authorid'] != $_G['uid']) {
            Tool::getInstance()->fail_json(Code::THREAD_READPERM, Tool::getInstance()->lang('read permission should over {readperm}', array('{readperm}' => $_G['forum_thread']['readperm'])));
        }
        /*******************************主题帖、回帖******************************************/
        //topic post
        $topicInfo = array();
        $post = DB::fetch_first("SELECT * FROM %t WHERE tid = %d AND first = 1",
            array(C::t('forum_post')->get_tablename('tid:' . $topic['tid']), $topic['tid']));

        if (!empty($post)) {
            $topicAuthor = C::t('common_member')->fetch_by_username($post['author']);

            //设置作者的STATUS（禁言等）
            $post['memberstatus'] = $topic['memberstatus'] = $topicAuthor['memberstatus'];

            $msg1 = Tool::getInstance()->lang('shield by manager to user');
            $msg2 = Tool::getInstance()->lang('shield by manager');
            $msg3 = Tool::getInstance()->lang('author shield by manager to user');
            $msg4 = Tool::getInstance()->lang('author shield by manager');
            //处理主题帖内容：CONTENT
            $content = ForumThread::parsePostMessage($post, 1);
            //分类信息显示
            $sortContent = '';
            $sortImg = array();
            //帖子被屏蔽的话 分类信息不显示
            if (!in_array($content, array($msg1, $msg2, $msg3, $msg4))) {
                if ($topic['sortid'] && $_G['forum']['threadsorts']['types'][$topic['sortid']]) {
                    $sort = $_G['forum']['threadsorts']['types'][$_G['forum_thread']['sortid']];
                    $threadsortshow = ForumThread::getSortInfo($topic['sortid'], $_G['tid'], $sort, $topic['dateline']);
                    list($sortContent, $sortImg) = $threadsortshow;
                }
            }

            // 处理图片重复问题
            if (!empty($sortImg)) {
                foreach ($sortImg as $k => $v) {
                    $v = str_replace('/', '\/', $v);
                    if (preg_match('/<img([^<]*)src=\"' . $v . '\".*?>/i', $content, $matches)) {
                        $content = str_replace($matches[0], '', $content);
                    }
                }
            }
            $content = $sortContent . $content;

            // 修正帖子查看数
            if (isset($_G['forum_thread']['views']) && $_G['forum_thread']['tid'] == $topic['tid'] && $_G['forum_thread']['views'] > $topic['views']) {
                $topic['views'] = $_G['forum_thread']['views'];
            }
            //活动贴的重新组织
            if ($topic['special'] == 4) {

                $re = ForumThread::getActivityThread($topic,$content);
                $content = $re['con'];
                $topicInfo['activity'] = $re['re'];
            }
            //商品的重新组织
            if ($topic['special'] == 2) {
                $re = ForumThread::getTradeThread($topic);
                $extra_pid = $re['pid'];
                $content = $content . $re['con'];
            }

            //组织云端内容字段
            $topicInfo['tid'] = $topic['tid'];
            $topicInfo['subject'] = $topic['subject'];
            $topicInfo['fid'] = $topic['fid'];
            $topicInfo['fname'] = $_G['forum']['name'];
            $topicInfo['icon'] = discuz_uc_avatar($topic['authorid'], 'big', true);
            $topicInfo['author'] = $topic['author'];
            $topicInfo['authorid'] = $topic['authorid'];
            $topicInfo['ifcheck'] = $topic['displayorder'] < 0 ? 0 : 1;
            $topicInfo['postdate'] = $topic['dateline'];
            $topicInfo['lastpost'] = $topic['lastpost'];
            $topicInfo['lastposter'] = $topic['lastposter'];
            $topicInfo['hits'] = $topic['views'];
            $topicInfo['replies'] = $topic['replies'];
            $topicInfo['favors'] = $topic['favtimes'];
            $topicInfo['topped'] = $topic['displayorder'] > 0 ? 1 : 0;
            $topicInfo['digest'] = $topic['digest'];
            $topicInfo['special'] = $topic['special'];
            $topicInfo['ifupload'] = $topic['attachment'] > 0 ? 1 : 0;
            //获取作者的性别
            $topicInfo['gender'] = DB::result_first("SELECT gender FROM " . DB::table("common_member_profile") . " WHERE uid=%d", array($topic['authorid']));
            $topicInfo['content'] = $content;
            $topicInfo['isFavored'] = DB::result_first('SELECT id FROM ' . DB::table('home_favorite') . ' WHERE id = %d AND uid = %d', array($topic['tid'], $_G['uid'])) ? 1 : 0;
            $topicInfo['isFollow'] = 0;

            /**********  wq_wechatcollection ******************/
            $topicInfo['content'] = ForumThread::handleWqwechatcollection($topicInfo['content'], $topicInfo['tid']);
//            global $postlist;
//            $postlist = array(
//                $post['pid'] => array(
//                    'first' => 1,
//                    'pid' => $post['pid'],
//                    'message' => ''
//                )
//            );
//            $this->_hook_wqwechatcollection();
//            if($postlist[$post['pid']]['message']){
//                $topicInfo['content']  = $postlist[$post['pid']]['message'];
//            }
            /**************************************************/

            //获取特殊用户组
            $topicInfo['specialgid'] = false;
            if (!empty(Yii::app()->params['qianfan_groupid']) && isset($topicAuthor['groupid']) && Yii::app()->params['qianfan_groupid'] == $topicAuthor['groupid']) {
                $topicInfo['specialgid'] = true;
            }

            //是否被赞
            if ($_G['uid']) {
                $isping = C::t('forum_memberrecommend')->fetch_by_recommenduid_tid($_G['uid'], $topic['tid']);
            } else {
                $isping = 0;
            }
            $topicInfo['isping'] = $isping;
            $topicInfo['pingCount'] = $topic['recommend_add'];

            //点评的用户
            $allPing = DB::fetch_all('SELECT recommenduid FROM ' . DB::table('forum_memberrecommend') . ' WHERE tid = %d limit 30', array($topic['tid']));
            $pinger = array();
            if (!empty($allPing)) {
                $pingUids = array();
                foreach ($allPing as $key => $ping) {
                    $pingUids[] = $ping['recommenduid'];
                }
                if (!empty($pingUids)) {
                    $pingerUsername = C::t('common_member')->fetch_all_username_by_uid($pingUids);
                    if (!empty($pingerUsername)) {
                        foreach ($pingerUsername as $key => $val) {
                            $pinger[] = array(
                                'uid' => $key,
                                'username' => $val,
                                'icon' => discuz_uc_avatar($key, 'big', true)
                            );
                        }
                    }
                }
            }

            $topicInfo['pinger'] = $pinger;
            if (!empty($post['attachments'])) {
                $allAttachs = array();
                foreach ($post['attachments'] as $key => $val) {
                    $allAttachs[]['url'] = $val['url'] . $val['attachment'];
                }
            }
            $topicInfo['allAttachs'] = $allAttachs;
            $topicInfo['unUsedAttachs'] = array();


            $_G['tid'] = $topicInfo['tid'];
            //特殊帖子处理 投票
            if ($topicInfo['special'] == 1) {
                $topicInfo['poll'] = ForumThread::getVoteInfo($_G['tid']);
            }

        }
        /************************************************************************************/

        /************************************获取回帖*****************************************/
        // 贴内置顶
        $sticklist = array();
        if (!$replypid) {
            if ($offset == 0 && $_G['forum_thread']['stickreply'] && !$isseemaster) {
                $poststick = C::t('forum_poststick')->fetch_all_by_tid($_G['tid']);
                foreach (C::t('forum_post')->fetch_all($_G['forum_thread']['posttableid'], array_keys($poststick)) as $post) {
                    $post['position'] = $poststick[$post['pid']]['position'];
                    $post['avatar'] = avatar($post['authorid'], 'small');
                    $post['isstick'] = true;
                    $sticklist[$post['pid']] = $post;
                }
            }
        }

        // 推荐帖子
        if ($is_new == 0) {
            $hiddenreplies = getstatus($_G['forum_thread']['status'], 2);
            $rushreply = getstatus($_G['forum_thread']['status'], 3);
            $hotpids = array();
            $hotpostarr = array();

            $remainhots = ($offset == 0 && !$rushreply && !$hiddenreplies && !$_G['forum_thread']['special'] && !$_G['forum']['noforumrecommend'] && empty($isseemaster)) ? $_G['setting']['threadhotreplies'] : 0;
            if ($remainhots) {
                $hotpids = array_keys(C::t('forum_hotreply_number')->fetch_all_by_tid_total($_G['tid'], 10));
                $remainhots = $remainhots - count($hotpids);
            }
            if ($_G['setting']['nofilteredpost'] && $_G['forum_thread']['replies'] > $_G['setting']['postperpage'] && $remainhots) {
                $hotpids = array_merge($hotpids, array_keys(C::t('forum_filter_post')->fetch_all_by_tid_postlength_limit($_G['tid'], $remainhots)));
            }
            if ($hotpids) {
                $hotposts = C::t('forum_post')->fetch_all_by_pid($_G['forum_thread']['posttableid'], $hotpids);
                foreach ($hotpids as $hotpid) {
                    if ($hotposts[$hotpid]) {
                        $hotpostarr[$hotpid] = $hotposts[$hotpid];
                        $hotpostarr[$hotpid]['hotrecommended'] = true;
                    }
                }
                unset($hotposts);
            }

        } else {


            $hotpostarr = array();

            $postSql = " SELECT a.*,b.support FROM %t a LEFT JOIN %t b ON a.pid = b.pid WHERE a.tid = $tid AND a.first != 1 AND a.invisible >= 0 AND b.support >=$supportnum ORDER BY b.support DESC LIMIT $supportlimit";

            $hotpostarrs = DB::fetch_all($postSql, array('forum_post', 'forum_hotreply_number'));
            foreach ($hotpostarrs as $key => $post) {
                $hotpostarr[$post['pid']] = $post;
            }
            unset($hotpostarrs);

        }


        //是否仅作者可见
        $isOnlyAuthorTopic = getstatus($_G['forum_thread']['status'], 2) == 1 ? 1 : 0;

        //组织获取回帖SQL
        //invisible 审核状态
        $isseemaster = intval($isseemaster);//只看楼主
        $authorid = intval($topicInfo['authorid']);


        if (!$replypid) {
            if ($is_new == 0 || $supportorder == 2) //状态值为2的时候  表示关闭最赞排序,以楼层排序为主
            {
                if ($replyorder) {
                    $order = "dateline DESC";
                } else {
                    $order = "dateline ASC";
                }
                $postSql = "SELECT * FROM %t WHERE tid = %d AND `first` != %d AND invisible >= %d" . ($isseemaster ? ' AND authorid =' . $authorid : '') . " ORDER BY " . $order . "
                LIMIT
                %d, %d";
            } else {
                if ($supportorder) {
                    $order = "b.support DESC";
                } else {
                    $order = "b.support ASC";
                }
                $postSql = "SELECT a.* FROM %t a LEFT JOIN " . DB::table("forum_hotreply_number ") . " b ON a.pid = b.pid WHERE a.tid = %d AND `first` != %d AND invisible >= %d" . ($isseemaster ? ' AND a.authorid =' . $authorid : '') . " ORDER BY " . $order . "
                LIMIT
                %d, %d";

            }

            $postList = DB::fetch_all($postSql, array(
                C::t('forum_post')->get_tablename('tid:' . $tid),
                $tid, 1, 0,
                dintval($offset), dintval($limit)));
        } else {
            // 优化通过消息中心进入帖子
            $postList = DB::fetch_all("SELECT * FROM %t WHERE tid = %d AND `first` != %d AND pid= %d LIMIT 1",
                array(C::t('forum_post')->get_tablename('tid:' . $tid), $tid, 1, $replypid));
            if (!empty($postList)) {
                if ($postList[0]['invisible'] == -5 || $postList[0]['invisible'] == -3) {
                    $postList[0]['message'] = Tool::getInstance()->lang('thread not exists');
                } elseif ($postList[0]['invisible'] == -2) {
                    $postTemp = array();
                    if (preg_match_all('/\[qf_at=(.+?)\](.+?)\[\/qf_at\]/', $postList[0]['message'], $matches)) {
                        foreach ($matches[1] as $k => $v) {
                            if ($_G['uid'] > 0 && $v == $_G['uid']) {
                                $postTemp = $postList;
                                break;
                            }
                        }
                    }
                    $postList = $postTemp;
                } elseif ($postList[0]['invisible'] == 0) {
                    $postList = $postList;
                } else {
                    $postList = array();
                }
            }
        }
        //回复量没记录时，兼容下
        if(is_array($postList) && !empty($postList)){
            $replies_num = count($postList);
            if($topicInfo['replies'] == 0 && $replies_num !=0)
                $topicInfo['replies'] = $replies_num;
        }

        if ($postList) {
            $tempPids = $tempUids = array();
            $tempPostRecommends = array();
            foreach ($postList as $post) {
                $tempPids[] = dintval($post['pid']);
                $tempUids[] = dintval($post['authorid']);
            }

            // 回帖点赞数量
            $hotreplyNumber = C::t('forum_hotreply_number')->fetch_all_by_pids(array_values($tempPids));
            if (!empty($hotreplyNumber)) {
                foreach ($hotreplyNumber as $pid => $post) {
                    $tempPostRecommends[$pid] = dintval($post['support']);
                }
            }

            // 当前用户是否点赞回复
            $isSupportAry = DB::fetch_all("SELECT pid FROM %t WHERE uid=%d AND pid IN (%n)", array('forum_hotreply_member', $_G['uid'], $tempPids));
            $isSupport = array();
            if (!empty($isSupportAry)) {
                foreach ($isSupportAry as $key => $val) {
                    $isSupport[] = $val['pid'];
                }
            }

            // 回复者的性别
            $genders = array();
            $tempUids = array_unique($tempUids);
            $genderArr = DB::fetch_all("SELECT uid,gender FROM %t WHERE uid IN (%n)", array('common_member_profile', $tempUids));
            if (!empty($genderArr)) {
                foreach ($genderArr as $k => $v) {
                    $genders[$v['uid']] = $v['gender'];
                }
            }

        }

        // 帖子内置顶组合回复列表，首页支持去重
        if ($is_new == 0) //使用老版的置顶加推荐的方式
        {
            if (!empty($sticklist) || !empty($hotpostarr)) {
                foreach ($postList as $key => $val) {
                    if (isset($sticklist[$val['pid']])) {
                        unset($postList[$key]);
                    }
                    if (isset($hotpostarr[$val['pid']])) {
                        unset($postList[$key]);
                    }
                }
                $postList = (array)$sticklist + (array)$hotpostarr + $postList;
            }
        } else {
            $posthot = array();
            //获取全部评论数量
            $all_postlist_num = $topicInfo['replies'];
            if ($all_postlist_num >= $commentlimit) {
                $posthot = (array)$sticklist + (array)$hotpostarr;
            } else if ($all_postlist_num < $commentlimit && isset($sticklist)) {
                $posthot = $sticklist;//只要有置顶的优先显示
            }
        }

        //遍历所有回复
        $replies = array();
        if (!empty($postList)) {
            foreach ($postList as $key => $val) {
                $postdateline = $val['dateline'];

                $content = ForumThread::parsePostMessage($val);
                //是否仅作者可见
                $isOnlyAuthorSeeReply = 0;
                if ($isOnlyAuthorTopic && $_G['uid'] != $val['authorid'] && $_G['uid'] != $_G['forum_thread']['authorid'] && !$val['first'] && !$_G['forum']['ismoderator']) {
                    $isOnlyAuthorSeeReply = 1;
                }

                $content = $isOnlyAuthorSeeReply ? Tool::getInstance()->lang('hiddenreplies') : $content;
                $attachs = C::t('forum_attachment_n')->fetch_all_by_id('pid:' . $val['pid'], 'pid', $val['pid'], '', 1);

                $allAttachs = array();
                if (!empty($attachs)) {
                    foreach ($attachs as $k => $attach) {
                        $attachs[$k]['url'] = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']) . 'forum/';
                        $attachs[$k]['attachment'] = $attachs[$k]['url'] . $attachs[$k]['attachment'];

                        $allAttachs[]['url'] = $attachs[$k]['attachment'];
                    }
                }

                //每个评论投票数和是否点赞
                $support_num = isset($tempPostRecommends[$val['pid']]) ? $tempPostRecommends[$val['pid']] : 0;

                //判断当前登录用户是否对该帖点赞没有
                $is_support = in_array($val['pid'], $isSupport) ? 1 : 0;


                $reply = array(
                    'pid' => $val['pid'],
                    'tid' => $val['tid'],
                    'author' => $val['author'],
                    'authorid' => $val['authorid'],
                    'icon' => discuz_uc_avatar($val['authorid'], 'big', 1),
                    'gender' => isset($genders[$val['authorid']]) ? $genders[$val['authorid']] : 0,
                    'postdate' => $postdateline,
                    'subject' => '',
                    'content' => $content,
                    'allAttachs' => $allAttachs,
                    'unUsedAttachs' => array(),


                    'support_num' => $support_num,
                    'is_support' => $is_support,
                    'position' => $val['position']
                );
                //针对商品中多余的楼层转移
                if ($topic['special'] == 2 && !empty($extra_pid) && in_array($val['pid'], $extra_pid)) {
                    $topicInfo['content'] = str_replace('[re]' . $val['pid'] . '[/re]', $content, $topicInfo['content']);
                    continue;
                }
                $replies[] = $reply;
            }
        }


        //遍历所有的热门评论
        if ($is_new == 1) {
            $hotpings = array();
            if (!empty($posthot)) {

                $hotPids = $hotUids = array();
                $hotPostRecommends = array();
                foreach ($posthot as $post) {
                    $hotPids[] = dintval($post['pid']);
                    $hotUids[] = dintval($post['authorid']);
                }

                // 回帖点赞数量
                $hotreplyNumber = C::t('forum_hotreply_number')->fetch_all_by_pids(array_values($hotPids));
                if (!empty($hotreplyNumber)) {
                    foreach ($hotreplyNumber as $pid => $post) {
                        $hotPostRecommends[$pid] = dintval($post['support']);
                    }
                }

                // 当前用户是否点赞回复
                $isSupportAry = DB::fetch_all("SELECT pid FROM %t WHERE uid=%d AND pid IN (%n)", array('forum_hotreply_member', $_G['uid'], $hotPids));
                $ishotSupport = array();
                if (!empty($isSupportAry)) {
                    foreach ($isSupportAry as $key => $val) {
                        $ishotSupport[] = $val['pid'];
                    }
                }


                // 回复者的性别
                $genders = array();
                $hotUids = array_unique($hotUids);
                $hotgenderArr = DB::fetch_all("SELECT uid,gender FROM %t WHERE uid IN (%n)", array('common_member_profile', $hotUids));
                if (!empty($hotgenderArr)) {
                    foreach ($hotgenderArr as $k => $v) {
                        $hotgenders[$v['uid']] = $v['gender'];
                    }
                }


                foreach ($posthot as $key => $val) {
                    $postdateline = $val['dateline'];

                    $content = ForumThread::parsePostMessage($val);
                    $msg1 = Tool::getInstance()->lang('shield by manager to user');
                    $msg2 = Tool::getInstance()->lang('shield by manager');
                    $msg3 = Tool::getInstance()->lang('author shield by manager to user');
                    $msg4 = Tool::getInstance()->lang('author shield by manager');
                    if (in_array($content, array($msg1, $msg2, $msg3, $msg4))) {
                        unset($val);
                        continue;
                    }

                    //是否仅作者可见
                    $isOnlyAuthorSeeReply = 0;
                    if ($isOnlyAuthorTopic && $_G['uid'] != $val['authorid'] && $_G['uid'] != $_G['forum_thread']['authorid'] && !$val['first'] && !$_G['forum']['ismoderator']) {
                        $isOnlyAuthorSeeReply = 1;
                    }

                    $content = $isOnlyAuthorSeeReply ? Tool::getInstance()->lang('hiddenreplies') : $content;
                    $attachs = C::t('forum_attachment_n')->fetch_all_by_id('pid:' . $val['pid'], 'pid', $val['pid'], '', 1);

                    $allAttachs = array();
                    if (!empty($attachs)) {
                        foreach ($attachs as $k => $attach) {
                            $attachs[$k]['url'] = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']) . 'forum/';
                            $attachs[$k]['attachment'] = $attachs[$k]['url'] . $attachs[$k]['attachment'];

                            $allAttachs[]['url'] = $attachs[$k]['attachment'];
                        }
                    }

                    //每个评论投票数和是否点赞
                    //取消判断是否开启点赞功能
                    $support_num = isset($hotPostRecommends[$val['pid']]) ? $hotPostRecommends[$val['pid']] : 0;

                    //判断当前登录用户是否对该帖点赞没有
                    $is_support = in_array($val['pid'], $ishotSupport) ? 1 : 0;

                    //$is_stick = isset($val['isstick']) ? 1 : 0 ;//是否置顶
                    //$is_recommend = isset($val['hotrecommended']) ? 1 : 0 ;//是否推荐

                    $hotping = array(
                        'pid' => $val['pid'],
                        'tid' => $val['tid'],
                        'author' => $val['author'],
                        'authorid' => $val['authorid'],
                        'icon' => discuz_uc_avatar($val['authorid'], 'big', 1),
                        'gender' => isset($genders[$val['authorid']]) ? $hotgenders[$val['authorid']] : 0,
                        'postdate' => $postdateline,
                        'subject' => '',
                        'content' => $content,
                        'allAttachs' => $allAttachs,
                        'unUsedAttachs' => array(),

                        'support_num' => $support_num,
                        'is_support' => $is_support,
                        'position' => $val['position']
                    );
                    //针对商品中多余的楼层转移
                    if ($topic['special'] == 2 && !empty($extra_pid) && in_array($val['pid'], $extra_pid)) {
                        $topicInfo['content'] = str_replace('[re]' . $val['pid'] . '[/re]', $content, $topicInfo['content']);
                        continue;
                    }
                    $hotpings[] = $hotping;
                }
            }
            $data['hotpings'] = $hotpings;
        }


        $data['thread'] = $topicInfo;
        $data['replies'] = $replies;

        // 更新帖子阅读量
        ForumThread::updateThreadViews($topicInfo['threadtableid'], $readnum);

        echo Tool::getInstance()->success_json($data);
        /************************************************************************************/
    }

    public function actionGetthreadsinfo()
    {
        global $_G;

        $tids = WebHelper::getPost('tids', '');
        // 验证参数的合法性
        if (!preg_match('/[0-9,]+/', $tids)) {
            Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request'));
        }
        $data = array();
        if ($tids) {
            $tidAry = explode(',', $tids);

            // 一次至多获取100条帖子基本信息，否则视为攻击
            if (count($tidAry) >= 100) {
                Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request'));
            }

            if (!empty($tidAry)) {
                $threads = C::t("forum_thread")->fetch_all_by_tid($tidAry);

                //特殊贴标记字段 specialgid
                $specialgid = Yii::app()->params['qianfan_groupid'];
                $groupid = array();
                if ($specialgid) {
                    foreach ($threads as $k => $v) {
                        $authoridArr[$k] = $v['authorid'];
                    }
                    if (!empty($authoridArr)) {
                        $groupidArr = DB::fetch_all('SELECT * FROM %t WHERE uid IN (%n)', array('common_member', $authoridArr));
                        if (!empty($groupidArr)) {
                            foreach ($groupidArr as $kk => $vv) {
                                $groupid[$vv['uid']] = $vv['groupid'];
                            }
                        }
                    }
                }

                if (!empty($threads)) {
                    if ($_G['setting']['optimizeviews']) {
                        $threadsoptimize = DB::fetch_all("SELECT * FROM %t WHERE tid in (%n)", array
                        ("forum_threadaddviews", $tidAry));
                    }

                    foreach ($threads as $key => $thread) {
                        $d = array();
                        $d['views_num'] = $thread['views'];
                        $d['replies_num'] = $thread['replies'];
                        $d['likes_num'] = $thread['favtimes'];
                        $d['specialgid'] = (!empty(Yii::app()->params['qianfan_groupid']) && $groupid[$thread['authorid']] == $specialgid) ? true : false;

                        //2.0需要使用字段,所以添加以下的
                        $d['tid'] = $thread['tid'];
                        $d['subject'] = $thread['subject'];
                        $d['author'] = $thread['author'];

                        if (!empty($threadsoptimize)) {
                            foreach ($threadsoptimize as $k => $v) {
                                if ($v['tid'] == $thread['tid'] && $v['addviews']) {
                                    $d['views_num'] += $v['addviews'];
                                }
                            }
                        }

                        $data[$thread['tid']] = $d;
                    }
                }
            }
        }

        Tool::getInstance()->success_json($data);
    }

    /**
     * 获取帖子点赞列表
     */
    public function actionRecommendResult()
    {
        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }

        $tid = intval(WebHelper::getPost('tid', ''));
        $dateline = intval(WebHelper::getPost('dateline', ''));
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 10);

        $pinger = array();
        if ($tid > 0) {
            if ($dateline > 0) {
                $allPing = DB::fetch_all('SELECT recommenduid, dateline FROM ' . DB::table('forum_memberrecommend') . ' WHERE tid = %d AND dateline < %d limit %d',
                    array($tid, $dateline, $limit));
            } else {
                $allPing = DB::fetch_all('SELECT recommenduid, dateline FROM ' . DB::table('forum_memberrecommend') . ' WHERE tid = %d limit %d, %d',
                    array($tid, $offset, $limit));
            }
            if (!empty($allPing)) {
                $pingUids = array();
                foreach ($allPing as $key => $ping) {
                    $pingUids[$ping['dateline']] = $ping['recommenduid'];
                }
                $pingDate = array_flip($pingUids);
                if (!empty($pingUids)) {
                    $pingerUsername = C::t('common_member')->fetch_all_username_by_uid($pingUids);
                    foreach ($pingerUsername as $key => $val) {
                        $pinger[] = array(
                            'uid' => $key,
                            'username' => $val,
                            'icon' => discuz_uc_avatar($key, 'big', true),
                            'sign' => DB::result_first("SELECT sightml FROM %t WHERE uid=%d LIMIT 1", array("common_member_field_forum", $key)),
                        );
                    }

                }
            }

        }
        Tool::getInstance()->success_json($pinger);
    }

    private function _hook_wqwechatcollection(){
        global $postlist;
        if (file_exists(DISCUZ_ROOT . './source/plugin/wq_wechatcollecting/hooks.class.php')) {
            @include DISCUZ_ROOT . './source/plugin/wq_wechatcollecting/hooks.class.php';
            if (class_exists('plugin_wq_wechatcollecting_forum')) {
                $hookObj = new plugin_wq_wechatcollecting_forum();
                if (method_exists($hookObj, 'viewthread_posttop_output')) {
                    $hookObj->viewthread_posttop_output();
                    if( strtoupper(CHARSET) == 'GBK'){
                        foreach($postlist as $key => $post) {
                            $postlist[$key]['message'] = iconv('GBK', 'UTF-8//ignore', $postlist[$key]['message']);
                            $postlist[$key]['message'] = iconv('UTF-8', 'GBK', $postlist[$key]['message']);
                        }
                    }

                }
            }
        }
    }
    public function actionActivityUser(){
        $tid = intval(WebHelper::getPost('tid', ''));
        $offset = intval(WebHelper::getPost('offset', ''));
        $limit = intval(WebHelper::getPost('limit', ''));

        $user = array();
        if($tid){
            $apply = DB::fetch_all( "SELECT * FROM %t WHERE tid = %d ORDER BY `applyid` DESC LIMIT %d,%d",array('forum_activityapply',$tid,$offset,$limit) );
            if(!empty($apply)){
                if (!function_exists( 'discuz_uc_avatar')) {
                    require_once(libfile('function/forum'));
                }
                foreach($apply as $val){
                    $user[] = array(
                        'uid'=>intval($val['uid']),
                        'username'=>$val['username'],
                        'icon'=>discuz_uc_avatar($val['uid'], 'big', true)
                    );
                }

            }
        }
        Tool::getInstance()->success_json($user);
    }
    //取消活动报名
    public function actionUnAttend(){
        global $_G;
        if(!$_G['uid']){
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
        }
        $tid = intval(WebHelper::getPost('tid', ''));
        $message = WebHelper::getPost('message', '');       //留言

        $_G['tid'] = $tid;
        $thread = C::t('forum_thread')->fetch_by_tid_displayorder($_G['tid'], 0);

        C::t('forum_activityapply')->delete_for_user($_G['uid'], $_G['tid']);
        $applynumber = C::t('forum_activityapply')->fetch_count_for_thread($_G['tid']);
        C::t('forum_activity')->update($_G['tid'], array('applynumber' => $applynumber));
        $message = cutstr(dhtmlspecialchars($message), 200);
        if($thread['authorid'] != $_G['uid']) {
            notification_add($thread['authorid'], 'activity', 'activity_cancel', array(
                'tid' => $_G['tid'],
                'subject' => $thread['subject'],
                'reason' => $message
            ));
        }
        Tool::getInstance()->success_json(array('return'=>'success'));
    }

    //报名参加活动
    public function actionAttend(){
        global $_G;
        if(!$_G['uid']){
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
        }
        $tid = intval(WebHelper::getPost('tid', ''));
        $payment = WebHelper::getPost('payment', '');               //支付为金额，承担自己消费为-1
        $data =  Yii::app()->request->getPost( 'data', '' );                        //json字段

        if(strtoupper( Yii::app()->params['site_charset'] ) != 'UTF-8' ){
            //必须是utf8编码
            $data = iconv( 'GBK', 'UTF-8//IGNORE', $data );
        }
        $data = json_decode($data,true);

        if(is_array($data) && !empty($data)){
            $message = isset($data['message']) ? $data['message'] : '';
            if( strtoupper( Yii::app()->params['site_charset'] ) != 'UTF-8' ){
                $message = iconv( 'UTF-8', 'GBK//IGNORE', $message );
            }
        }else{
            Tool::getInstance()->fail_json( Code::UNDEFINED_ACTION, Tool::getInstance()->lang( 'undefined action' ) );
        }

        $_G['tid'] = $tid;
        $thread = C::t('forum_thread')->fetch_by_tid_displayorder($_G['tid'], 0);
        $activity = C::t('forum_activity')->fetch($_G['tid']);

        if($activity['expiration'] && $activity['expiration'] < TIMESTAMP) {
            Tool::getInstance()->fail_json(Code::ACTIVITY_ERROR, lang('message', 'activity_stop'));
        }
        $applyinfo = C::t('forum_activityapply')->fetch_info_for_user($_G['uid'], $_G['tid']);
        if($applyinfo && $applyinfo['verified'] < 2) {
            Tool::getInstance()->fail_json(Code::ACTIVITY_ERROR, lang('message', 'activity_repeat_apply'));
        }
        //参数
        $message = cutstr(dhtmlspecialchars($message), 200);
        $verified = $thread['authorid'] == $_G['uid'] ? 1 : 0;
        if($activity['ufield']) {
            $ufielddata = array();
            $activity['ufield'] = dunserialize($activity['ufield']);
            if(!empty($activity['ufield']['userfield'])) {
                $censor = discuz_censor::instance();
                loadcache('profilesetting');
                foreach($activity['ufield']['userfield'] as $filedname) {
                    //电话 名字 qq
                    $value = isset($data[$filedname]) ? $data[$filedname] : '';
                    if( strtoupper( Yii::app()->params['site_charset'] ) != 'UTF-8' ){
                        $value = iconv( 'UTF-8', 'GBK//IGNORE', $value );
                    }
                    if(is_array($value)) {
                        $value = implode(',', $value);
                    }
                    //长度限制200字符
                    $value = cutstr(dhtmlspecialchars(trim($value)), 200, '.');
                    if($_G['cache']['profilesetting'][$filedname]['formtype'] == 'file' && !preg_match("/^https?:\/\/(.*)?\.(jpg|png|gif|jpeg|bmp)$/i", $value)) {
                        Tool::getInstance()->fail_json(Code::ACTIVITY_ERROR, lang('message', 'activity_imgurl_error'));
                    }
                    if(empty($value) && $filedname != 'residedist' && $filedname != 'residecommunity') {
                        Tool::getInstance()->fail_json(Code::ACTIVITY_ERROR, lang('message', 'activity_exile_field'));
                    }
                    $ufielddata['userfield'][$filedname] = $value;
                }
            }
            if(!empty($activity['ufield']['extfield'])) {
                foreach($activity['ufield']['extfield'] as $fieldid) {
                    $value = isset($data[$fieldid]) ? $data[$fieldid] : '';
                    if( strtoupper( Yii::app()->params['site_charset'] ) != 'UTF-8' ){
                        $value = iconv( 'UTF-8', 'GBK//IGNORE', $value );
                    }
                    $ufielddata['extfield'][$fieldid] = cutstr($value, 50, '.');
                }
            }
            $ufielddata = !empty($ufielddata) ? serialize($ufielddata) : '';
        }
        //威望值的 增减 可以忽略
        if($_G['setting']['activitycredit'] && $activity['credit'] && empty($applyinfo['verified'])) {
            checklowerlimit(array('extcredits'.$_G['setting']['activitycredit'] => '-'.$activity['credit']));
            updatemembercount($_G['uid'], array($_G['setting']['activitycredit'] => '-'.$activity['credit']), true, 'ACC', $_G['tid']);
        }
        if($applyinfo && $applyinfo['verified'] == 2) {
            $newinfo = array(
                'tid' => $_G['tid'],
                'username' => $_G['username'],
                'uid' => $_G['uid'],
                'message' => $message,
                'verified' => $verified,
                'dateline' => $_G['timestamp'],
                'payment' => $payment,
                'ufielddata' => $ufielddata
            );
            C::t('forum_activityapply')->update($applyinfo['applyid'], $newinfo);
        } else {
            $data = array('tid' => $_G['tid'], 'username' => $_G['username'], 'uid' => $_G['uid'], 'message' => $message, 'verified' => $verified, 'dateline' => $_G['timestamp'], 'payment' => $payment, 'ufielddata' => $ufielddata);
            C::t('forum_activityapply')->insert($data);
        }

        $applynumber = C::t('forum_activityapply')->fetch_count_for_thread($_G['tid']);
        C::t('forum_activity')->update($_G['tid'], array('applynumber' => $applynumber));

        if($thread['authorid'] != $_G['uid']) {
            if(function_exists('notification_add')){
                notification_add($thread['authorid'], 'activity', 'activity_notice', array(
                    'tid' => $_G['tid'],
                    'subject' => $thread['subject'],
                ));
            }
            $space = array();
            if(function_exists('space_merge')){
                space_merge($space, 'field_home');
            }
            if(!empty($space['privacy']['feed']['newreply']) && function_exists('postfeed') ) {
                $feed['icon'] = 'activity';
                $feed['title_template'] = 'feed_reply_activity_title';
                $feed['title_data'] = array(
                    'subject' => "<a href=\"forum.php?mod=viewthread&tid=$_G[tid]\">$thread[subject]</a>",
                    'hash_data' => "tid{$_G[tid]}"
                );
                $feed['id'] = $_G['tid'];
                $feed['idtype'] = 'tid';
                postfeed($feed);
            }
        }
        Tool::getInstance()->success_json(array('return'=>'success'));
    }

}
